"""
Copyright (c) 2009 [name + "(at)student.hpi.uni-potsdam.de" for name in ["murat.knecht", "franziska.haeger", "christian.schwarz"]]

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"""


import pygame

from gamemenu import GameMenu


class MainController(object):
    
    def __init__(self):
        """Initialize the demo."""        
        object.__init__(self)
        self.initialize_pygame()
        
        self.leftArrow  = False
        self.rightArrow = False
        self.upArrow    = False
        self.downArrow  = False
    
    def initialize_pygame(self):
        """Initializes the pygame sub system."""
        pygame.init()
        
        self.window = pygame.display.set_mode((1024,768), pygame.DOUBLEBUF | pygame.RESIZABLE)
        pygame.display.set_caption("Spawnmower Lawn Defense")
        
        self.screen = pygame.display.get_surface()
        self.clock = pygame.time.Clock()

    def run(self):
        """Runs the mainloop of the demo."""
        # Start with the menu
        menu = GameMenu(self.screen, self)
        
        # Run until self.handle_events tells to close the demo
        menu.run()
        #while menu.execution_loop():
        #    # updates all Sprites and draws them to the screen
        #    
        #    # flips the display buffers
        #    pygame.display.flip()
        #    
        #    self.tick()

    def tick(self, clockrate=50):
        """Uses the PyGame clock to set the maximum fps.
        
        @param clockrate Sets the maximum number of frames per second.
        """
        return self.clock.tick(clockrate)
    

def main():
    MainController().run()

